//+------------------------------------------------------------------+
//|                                        Expert_for_Ulian84 v2.mq4 |
//|                                                            |
//|                                                                  |
//+------------------------------------------------------------------+
//  TimeQuota     
#property copyright ""
#property link      ""

//---- input parameters
extern double    Lots=0.1;
extern int       StopLoss=25;
extern int       TakeProfit=29;
extern int       TrailingStop=25;
extern int       Step=5;//  
extern int       TimeQuota=15;
extern int       i.Period=14;
extern double    i.UpLevel=0.85;
extern double    i.LowLevel=0.15;
extern int       i.BarSignal=0;//      : 0-   
extern int       magic=777;
//----
int ticket,STOPLEVEL;
double stoploss,takeprofit;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

//----

double DM.1=iDeMarker(NULL,0,i.Period,i.BarSignal);
double DM.2=iDeMarker(NULL,0,i.Period,i.BarSignal+1);

  if(TimeSignal()==true)//   
    {
    ticket=-1;
  //---- BUY
    if(DM.2<i.LowLevel && DM.1>i.LowLevel)//    BUY
      {
      if(StopLoss>STOPLEVEL){stoploss=NormalizeDouble(Bid-StopLoss*Point,Digits);}
      else {stoploss=0;}
      if(TakeProfit>STOPLEVEL){takeprofit=NormalizeDouble(Bid+TakeProfit*Point,Digits);}
      else {takeprofit=0;}
      
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,stoploss,takeprofit,NULL,magic,0,Blue);
      if(ticket<0)
        {
        Print("   BUY  #",GetLastError());
        return(0);
        }
      }
  //---- SELL
    if(DM.2>i.UpLevel && DM.1<i.UpLevel)//    SELL
      {
      if(StopLoss>STOPLEVEL){stoploss=NormalizeDouble(Ask+StopLoss*Point,Digits);}
      else {stoploss=0;}
      if(TakeProfit>STOPLEVEL){takeprofit=NormalizeDouble(Ask-TakeProfit*Point,Digits);}
      else {takeprofit=0;}
      
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,stoploss,takeprofit,NULL,magic,0,Red);
      if(ticket<0)
        {
        Print("   SELL  #",GetLastError());
        return(0);
        }
      }
    }
    
//----   
  if(TrailingStop>STOPLEVEL)
    {
    for(int pos=OrdersTotal()-1;pos>=0;pos--)
      {
      if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
        {
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
          {
        //----
          if(OrderType()==OP_BUY)
            {
            if(Bid>OrderStopLoss()+(TrailingStop+Step)*Point)
              {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,OrderTakeProfit(),0,Blue);
              }
            }
        //----
          if(OrderType()==OP_SELL)
            {
            if(Ask<OrderStopLoss()-(TrailingStop+Step)*Point)
              {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,Red);
              }
            }
        //----
          }
        }
      else Print("         (",GetLastError(),")");
      }    
    }

//----
   return(0);
  }
//+------------------------------------------------------------------+
bool TimeSignal()
  {
  datetime TimeOpenOrderReal,TimeOpenOrderHistory;int pos;
//----
  for(pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
        {
        if(OrderOpenTime()>TimeOpenOrderReal || TimeOpenOrderReal==0)
          {
          TimeOpenOrderReal=OrderOpenTime(); 
          }        
        }
      }
    else Print("         (",GetLastError(),")");
    }
//----
   for(pos=OrdersHistoryTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_HISTORY)==true)
      {
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
        {
        if(OrderOpenTime()>TimeOpenOrderHistory || TimeOpenOrderHistory==0)
          {
          TimeOpenOrderHistory=OrderOpenTime(); 
          }             
        }
      }
    else Print("      (",GetLastError(),")");
    }
//----

  if((TimeCurrent()-MathMax(TimeOpenOrderReal,TimeOpenOrderHistory))/3600>=TimeQuota) {return(true);}
  else {return(false);}   
  }

